package sun.reflect;

import java.lang.reflect.InvocationTargetException;
import sun.reflect.misc.ReflectUtil;
import java.lang.reflect.Method;

class NativeMethodAccessorImpl extends MethodAccessorImpl
{
    private final Method method;
    private DelegatingMethodAccessorImpl parent;
    private int numInvocations;
    
    NativeMethodAccessorImpl(Method method) {
        this.method = method;
    }
    
    @Override
    public Object invoke(Object o, Object[] array) throws IllegalArgumentException, InvocationTargetException {
        if (++this.numInvocations > ReflectionFactory.inflationThreshold() && !ReflectUtil.isVMAnonymousClass(this.method.getDeclaringClass())) {
            this.parent.setDelegate((MethodAccessorImpl)new MethodAccessorGenerator().generateMethod(this.method.getDeclaringClass(), this.method.getName(), this.method.getParameterTypes(), this.method.getReturnType(), this.method.getExceptionTypes(), this.method.getModifiers()));
        }
        return invoke0(this.method, o, array);
    }
    
    void setParent(DelegatingMethodAccessorImpl parent) {
        this.parent = parent;
    }
    
    private static native Object invoke0(Method p0, Object p1, Object[] p2);
}
